
proc Map_To_Image {} {

    global env _MapFile _NewImage _ImageFile _Mode

# If there is cuurently no image to be modified, inform user and return.
    if {$_ImageFile == ""} {
        postMessage "An Image is required on the canvas for it to be \
            modified. \n\
            \t \t Load one and try again."
        set _Mode map
        return
    }

    if {$_NewImage == ""} {
        postMessage " A browser will be displayed shortly. \n\
            Select a filename for the altered imagefile. \n\n\
            The image conversion software uses the image currently loaded on \
            the canvas to create the modified image. \n\
            Therefore it has been made impossible for you to overwrite \
            the existing image file.\n\
            Press OK to continue."

# Get a pathname for the new file.
        if {$_ImageFile != ""} {cd [file dirname $_ImageFile]}
        set return [Create_Browser]
        if {$_ImageFile != ""} {cd $env(MAP_MARKER)}

# If the filename part is not empty, set the path accordingly.
        if {[lindex $return 1] != ""} {
            set _NewImage "[lindex $return 0]/[lindex $return 1]"

            while {$_ImageFile == $_NewImage} {
                postMessage "DO NOT overwrite original Image"
                set return [Create_Browser]
                set _NewImage "[lindex $return 0]/[lindex $return 1]"
            }
            if {[catch "set newIf [open $_NewImage w]" msg] != 0} {
                postMessage " Cannot open file - $_NewImage - because : \n\ 
                    $msg"
            }
        }
        return
    } else {
        if {$_Mode != "maptoimage"} {
            if {[yesNo "Save modified image as : \n\ $_NewImage?"] == "NO"} {
                set _NewImage ""
                Map_To_Image
                return           
            }
        }
    }

# Get the contents of the mapfile, and set some defaults.
    set fileContents [Get_File_Contents $_MapFile]
    set colour red; set lineWidth 1; set type ""; set prevCol ""

    if {[catch "set editf [open $env(TEMPFILE) w]" msg] != 0} {
        postMessage " Cannot open file to store data for editimage because :\n\
            $msg"
    }

# Loop through each line of mapfile extracting relevant info for editimage.
    set index 0

    while {$index < [llength $fileContents]} {
        set line [lindex $fileContents $index]
        incr index
# If whitespace, goto next line.
        if {[regexp {^ *$} $line]} {
            continue
        }

# If this is a comment line, call proc that identifies comment values.
        if {[string range $line 0 0] == "#"} {
            Process_Comments $line colour lineWidth comments 0

            if {$prevCol != $colour} {
                set rgb [Set_Colour_Vals $colour]
                set prevCol $colour
# Write colour line to editfile.
                puts $editf "RGB $rgb"
            }
            if {$lineWidth == 0} {set lineWidth 1}
            puts $editf "WIDTH $lineWidth"
        } else {

            set type [Extract_URL_Coords $line URL coords]
# Write editline to editfile.
            if {$type != ""} {
                if {$type == "oval"} {
                    set type circle
                    set radius [expr ([lindex $coords 3]-[lindex $coords 1])/2]
                    set xc [expr [lindex $coords 0]+$radius]
                    set yc [expr [lindex $coords 1]+$radius]
                    set coords "$xc $yc $radius"
                }
                set type [string toupper $type]

                set index1 0
                foreach co $coords {
                    if {[string first . $co] == -1} {
                    } else {
                        set strInd [string first . $co]
                        set co [string range $co 0 [expr $strInd-1]]
                        lvarpop coords $index1 $co
                    }
                    incr index1
                }
                    puts $editf "$type $coords"
            }
        }
    }

    puts $editf "QUIT"
    close $editf
    Configure_Message_Widget "\n Saving modified image : \n $_NewImage"
    exec $env(EDITIMAGE) $_ImageFile $_NewImage <  $env(TEMPFILE)
    Set_Message 1

    Convert_To_Gif
}

proc Set_Colour_Vals {colName} {

    switch $colName {
        black { set rgb "0 0 0" }
        white { set rgb "255 255 255" }
        red { set rgb "255 0 0" }
        orange { set rgb "255 165 0" }
        yellow { set rgb "255 255 0" }
        green { set rgb "0 255 0" }
        blue { set rgb "0 0 255" }
        pink { set rgb "255 192 203" }
        violet { set rgb "238 130 238" }
        purple { set rgb "160 32 240" }
        default { set rgb "255 0 0" }
    }
    return $rgb
}

